% In this script we demonstarte how to perform symbolic calculations. 
clear %Clearing memory

%**************************************************************************
%  Example 1: Matrix algebra (symbilic)                                   *
%**************************************************************************
syms a b c d %Declaring symbolic variables
A = [a b; c d] %Matrix
det_A = det(A)
B = A.' %Transpose
D = det(A) %Determinant
invA = inv(A) %Inverse

%**************************************************************************
%  Example 2: Market equilibrium                                          *
%**************************************************************************
syms a b c d %Declaring symbolic variables
A = [1 b; 1 -d] %Matrix
x = inv(A)*[a; -c] %Solving for equilibrium by invertion A
x = A\[a; -c] %Solving for equilibrium by Gaussian Elimination


%Measuting the time of two algorithms for linear systems
n = 10000;
A = rand(n,n);
d = rand(n,1);

% Gaussian Elimination
tic
x1 = A\d;
toc

% Matrix inversion
tic
x2 = inv(A)*d;
toc

% Comparing the two solutions
norm(x1-x2)

%**************************************************************************
%  Example 2: Leontief Input-Output model                                           *
%**************************************************************************
A = [0.15  0.5	0.25;
     0.3   0.1	0.4;
     0.15  0.3	0.2] %Input-output matrix

T = eye(size(A)) - A; %Technology matrix or Leontief matrix

d = [20; 20; 10] %Consumer demand
x = T\d %Required production

d = [20; 20; 20] %Consumer demand
x = T\d %Required production

