%Gradient and Hessian of multivariate function
clear
close all

%**************************************************************************
%  Example 1                                                              *
%**************************************************************************
syms x1 x2 x3 %Declaring symbolic variables
f(x1,x2,x3) = 2*x1^2 + x1*x2 + 4*x2^2 + x1*x3 + x3^2 + 2; %Defining a function
grad = gradient(f(x1,x2,x3),[x1,x2,x3]); %Gradient vector 

%Finding critical valuesd
FOC = grad==0; %System of equations
[x1_star,x2_star,x3_star] = solve(FOC,[x1,x2,x3])

H = hessian(f(x1,x2,x3),[x1,x2,x3]); %Hessian matrix

%Leading principal minors
for i=1:length(H)
    PM(i) = det(H(1:i,1:i));   
end
disp('Leading principal minors')
PM

%**************************************************************************
%  Example 2                                                              *
%**************************************************************************
f(x1,x2) = x1^4 + x1^2 - 6*x1*x2 + 3*x2^2; %Defining a function
grad = gradient(f(x1,x2),[x1,x2]); %Gradient vector 

%Finding critical valuesd
FOC = grad==0; %System of equations
[x1_star,x2_star] = solve(FOC,[x1,x2]);

H = hessian(f(x1,x2),[x1,x2]); %Hessian matrix

%Leading principal minors
clear PM %Clear PM from last example
for i = 1:length(x1_star) %Loop over critical values
        for j=1:length(H) %Loop over Hessian dimention
        PM(i,j) = det(subs(H(1:j,1:j),[x1,x2],...
            [x1_star(i),x2_star(i)]));
    end
end
disp(',Crit points and Leading prin. minors')
[x1_star,x2_star,PM]

