% PV.m calculates the present value of a streal of payments, and given an
% interest rate r.
% 
% INPUTS:
%       X - vector containint the stream of payments
%       r - periodic interest rate
% 
% OUTPUT:
%       Y - present value of X
% 
% Usage: Y = PV(X,r)
function Y = PV(X,r)

N = length(X); %Number of paymnets
Y = 0; %Initializing
for t = 1:N
    Y = Y + X(t)/((1+r)^t);
end