% Speed test of solving linear systems A*x = d
clear

n = 5000; %Number of linear equations and unknowns
A = rand(n,n); %Matrx of coefficients
d = rand(n,1); %Vector of constants

% Matrix inversion 
tic 
x1 = inv(A)*d;
toc 

% Gaussian elimination
tic
x2 = A\d;
toc

X = [x1,x2]; %Comparing the two solutions
norm(x1-x2) %Differences between the two solutions
