# Checking the speed of linear equations solving

#Importing packages
import numpy as np #core library for scientific computing
import scipy.linalg as la #Linear Algebra
import time #Timing code


N = 5000 #Number of equations and unknowns in A*x = b
A = np.random.rand(N,N)
b = np.random.rand(N,1)

#Check the first entries of A:
# print(A[:3,:3])

#Check the first entries of A:
# print(b[:4,:])

#Matrix inversion
start_time = time.time()
x1 = la.inv(A) @ b
t1 = round(time.time() - start_time,6)

#Gaussian elimination
start_time = time.time()
x2 = la.solve(A,b)
t2 = time.time() - start_time

message = "Matrix Inverson time: {} seconds"
print(message.format(round(t1,6)))

message = "Gaussian Elimination time: {} seconds"
print(message.format(round(t2,6)))

message = "Difference in solution {}"
print(message.format(la.norm(x1-x2)))

