%circle.m plots a graph with any number of circles, with user provided
%radius and location (centers).
clear
close all

n = 300; %Number of circles
r = 0.1+rand(n,1); %Radius
center = -10+20*rand([n,2]); %Centers of the circles
figure(1)
for i = 1:n
    %Circle at origin
    x = linspace(-r(i),r(i),100)'; %grid points of x-axis
    y = sqrt(r(i)^2 - x.^2); %positive y-values
    c = rand(1,3);
    
    plot(x+center(i,1),y+center(i,2), x+center(i,1),-y+center(i,2),...
        'Color', rand(1,3), 'LineWidth',2);
    hold on
    pause(0.1)
end
title('Random Circles')
axis equal %adjusting aspect ratios
