% logb.m calculates the log base b of any real value x.
% Inputs:
%       x - real number, the variable of the function
%       b - base, must be: b > 0, and b ~= 1
% Output:
%       y = log base b of x
% Usage:
%       y = log(x,b)
function y = logb(x,b)
if b <= 0
    error('the base must be positive');
elseif b == 1    
    error('the base cannot be 1');
else
    y = log(x)/log(b); %Base conversion formula
end