% This function computes the periodic payment on a loan of size PV, anuual 
% percentage rate APR, and T monthly periods.
% 
% Inputs:
%       PV  - value of the mortage
%       APR - Annual Percentage Rate
%       T   - Number of payments
% 
% OUTPUT:
%       PMT - monthly payment
% 
% USAGE:
%       PMT = mortgageMichael(400000,0.045,360)
% 
function PMT = mortgage(PV,APR,T)
r = APR/12; %Monthly interest rate
if r == 0
    R = T;
else
    R = (1-(1/(1+r))^T)/r;
end
PMT = PV/R;

% Generate table of Balance, payment, and breaking the payment into the
% interest part and principal payment