%Quadraticmichael.m computes the roots of a quadratic polynomial:
% 
%      a*x^2 + b*x + c = 0
% Inputs:
%   a,b,c - the coefficients of the quadratic
% 
% Outputs:
%   [x1, x2] - the roots of the polynimial
% 
% Usage: 
% [x1, x2] = quadraticmichael(a,b,c) %Provide values a,b,c
function [x1, x2] = quadratic1(a,b,c)

delta = b^2 - 4*a*c;

if delta < 0
    error('No real solution found')
else
    x1 = (-b - delta^0.5)/(2*a);
    x2 = (-b + delta^0.5)/(2*a);
end




